Bug 112204 - X-Server needs a lot of memory
X-Server needs a lot of memory
Status: CLOSED CURRENTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: XFree86 (Show other bugs)
9
i686 Linux
medium Severity high
: ---
: ---
Assigned To: X/OpenGL Maintenance List
David Lawrence
http://www.boris-glawe.de/screenshot_...
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-12-15 20:47 EST by Boris Glawe
Modified: 2007-04-18 13:00 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-10-12 13:23:47 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Boris Glawe 2003-12-15 20:47:40 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.6b)
Gecko/20031210

Description of problem:
Hi,

I am using RH9 on a PII350 with 256 MB RAM and about 800MB swap. My
graphic card is an Nividia Riva 128zx. With the X-Server I am using
the "nv" driver.
I usually boot to runlevel 3 and start the X-Server with either
"startx" or with "startxfce4" (http://www.xfce.org).
No matter which desktop environment I start, the X-server needs about
35-40MB of RAM  in the beginning. After having worked for a few hours,
the memory usage usually increases up to 100-150MB. The top value I've
measured can be seen in the screenshot above: 335MB (!). I cannot
believe, that this is normal !
Ok, I am working with eclipse and mozilla, which both need a lot of
RAM, but closing such apps won't lead to a decrease of memory usage.
Maybe there's a memoryleak in the nv driver !? It must be a component
of the X-server, which is special to my machine, since most people
don't have this X-server memory problem.

I've also experienced that my machine couldn't shut down the X-server,
due to high swapping. I've had no more keyboard or mouse access to my
machine then. After a few minutes the swapping stopped and I was
forced to reset the machine.

I hope, someone can help !

Version-Release number of selected component (if applicable):
XFree86-4.3.0-2.90.43

How reproducible:
Always

Steps to Reproduce:
1. start the X-server with a riva 128zx graphic card.
2. work with it for some hours.
3. 
    

Actual Results:  high memory usage, a lot of swapping.

Expected Results:  memory usage of about 40-55MB for the X-server

Additional info:

I don't know when this problem started, but I didn't have this problem
with RH9 in the beginning. Maybe there's a problem with the updated
XFree Version, which I've installed a few week/months ago !?
Comment 1 Mike A. Harris 2003-12-17 03:14:20 EST
Nothing you describe above is abnormal in any way.  You can not
interpret the memory usage reported by top or ps for the X server
in the same way you interpret other applications because:

1) It includes memory mapped video memory and MMIO hardware I/O
   register ranges, which can be anywhere from a few megabytes, to
   several hundred megabytes - neither of which are actual system
   memory.

2) X resources, which are stored _inside_ the X server, are
   allocated by applications, and remain in the X server until the
   application frees them or exits.  Any application can leak
   resources such as pixmaps, and this will cause the X server to
   increase in size, not the application.  People usually believe
   that the X server is at fault and has a memory leak in such cases,
   when it is not, and the application(s) are what is buggy.

99% of all "the X server is leaking memory" bug reports turn out to
be false, and so I have to assume that all such bug reports are
application bugs and resource leaks in the applications the user is
using, until the user can prove beyond a reasonable doubt that their
applications are not leaking resources or otherwise causing the X
server memory footprint to increase.

Now, you mention also that you did not have this problem in the
beginning, which I presume means when you installed Red Hat Linux 9.
Presumeably you've upgraded your entire system to the latest updates
available from up2date, and something has changed.  Can you downgrade
all of the XFree86 packages to the original XFree86 that shipped with
RHL 9, and reboot, and see if the problem persists?

While the likelyhood of this being an X server or video driver
memory leak is very slim, it is not impossible, but we will need
to see compelling evidence of this first before it can be examined.
Also, I do not have Nvidia Riva 128 video hardware, so I can't test
with that hardware.  Can you try another video card to see if the
problem persists?  That would be useful information.

Please attach your X server log file, config file, and
/var/log/messages as individual uncompressed file attachments using
the link below.
Comment 2 Mike A. Harris 2004-10-12 13:23:47 EDT
Since this bugzilla report was filed, there have been several major
updates to the X Window System, which may resolve this issue.  Users
who have experienced this problem are encouraged to upgrade to the
latest version of Fedora Core, which can be obtained from:

        http://fedora.redhat.com/download

If this issue turns out to still be reproduceable in the latest
version of Fedora Core, please file a bug report in the X.Org
bugzilla located at http://bugs.freedesktop.org in the "xorg"
component.

Once you've filed your bug report to X.Org, if you paste the new
bug URL here, Red Hat will continue to track the issue in the
centralized X.Org bug tracker, and will review any bug fixes that
become available for consideration in future updates.


Note You need to log in before you can comment on or make changes to this bug.